Index: orxonox/trunk/src/gui/orxonox_gui_gtk.cc
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui_gtk.cc	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui_gtk.cc	(revision 3423)
@@ -34,10 +34,7 @@
 // temporarily.
 #include "orxonox_gui_flags.h"
-#include "orxonox_gui_exec.h"
 extern Window* orxonoxGUI;
 extern OrxonoxGuiFlags* flags;
-extern OrxonoxGuiExec* exec;
-
-#ifdef HAVE_GTK2
+
 /**
    \brief Initializes the Guis GTK-stuff.
@@ -45,18 +42,93 @@
    \param argv The Argument strings.
 */
-bool initGTK(int argc, char *argv[])
-{
-  gtk_init (&argc, &argv);
+bool initGUI(int argc, char *argv[])
+{
+#ifdef HAVE_GTK2
+#ifdef HAVE_GTHREAD
+  PRINTF(3)("Initializing the ThreadSystem of the GUI\n");
+  g_thread_init(NULL);
+  gdk_threads_init();
+#endif /* HAVE_GTHREAD */
+  gtk_init(&argc, &argv);
   gtk_rc_parse( "rc" );
-}
-
-/**
-   \brief enters the GTK-main-loop
-*/
-bool mainloopGTK(void)
-{
+#endif /* HAVE_GTK2 */
+}
+
+
+/**
+   \brief enters the GUI's main-loop
+*/
+bool mainloopGUI(void)
+{
+#ifdef HAVE_GTK2
+  gdk_threads_enter();
   gtk_main();
-}
-#endif /* HAVE_GTK2 */
+  gdk_threads_leave();
+  delete Window::mainWindow;
+#else /* HAVE_GTK2 */
+  char boolAns = 'y';
+  char ans[10]; 
+  while(true)
+    {
+      PRINT(0)(" Listing all the Orxonox Options: \n");
+      PRINT(0)("  #############################\n");
+      Window::mainWindow->walkThrough(Widget::listOptionsAndGroups, 1);
+      
+      PRINT(0)("\nDo you want change any of the above values now? [Yn] ");
+      cin >>boolAns ;
+      if (boolAns =='n' || boolAns=='N')
+	break;
+      
+      PRINT(0)("\n Listing all groups\n");
+      PRINT(0)("  #################\n");
+      int groupCount = 0;
+      Window::mainWindow->walkThrough(Widget::listGroups, &groupCount, 1);
+      
+      PRINT(0)("\nIn which Group? [1-%d] ", groupCount);
+      Packer* group;
+      while(true)
+	{
+	  cin >> ans;
+	  int ansIp = atoi(ans);
+	  if (ansIp <= groupCount)
+	    {
+	      group = static_cast<Packer*>(Window::mainWindow->findGroupByNumber(&ansIp, 1));
+	      break;
+	    }
+	  else
+	    PRINT(0)("\nChoose a smaler Number please: [1-%d] ", groupCount);
+	}
+      PRINT(0)("\n\nGroup: [%s]\n\n", group->groupName);
+      int optionCount = 0;
+      group->walkThrough(Widget::listOptions, &optionCount, 0);
+      PRINT(0)("\nWhich Option? [1-%d] ", optionCount);
+      Option* option;
+      while(true)
+	{
+	  cin >> ans;
+	  int ansIp = atoi(ans);
+	  if (ansIp <= groupCount)
+	    {
+	      option = static_cast<Option*>(group->findOptionByNumber(&ansIp, 0));
+	      break;
+	    }
+	  else
+	    PRINT(0)("\nChoose a smaler Number please: [1-%d] ", optionCount);
+	}
+      PRINT(0)("\n\n:: %s ::\n", option->title);
+      option->changeOption();
+      
+      // here follows the rest.... this will be nasty.
+      //! \todo move this into the gui-gtk-file
+      //! \todo finish it.
+    }
+#endif /* HAVE_GTK2 */
+  
+}
+
+
+//////////////////////////////
+/// DEFINING WIDGET-CLASES ///
+//////////////////////////////
 
 /* WIDGET */
@@ -66,19 +138,7 @@
    This is still pretty crappy.
 */
-Widget::~Widget()
-{
-  //  cout << "hiding: " <<this->label <<"\n";
-  this->hide();
-  //  cout << "check if Packer: "<<this->label <<"\n";
-  if (this->isOption < 0)
-    {
-      //  cout << "get Down "<<this->label <<"\n";
-      static_cast<Packer*>(this)->down->~Widget();
-    }
-  //  cout << "next != NULL?: " <<this->label <<"\n";
-  if (this->next != NULL)
-    this->next->~Widget();
-  cout << "delete Widget: " <<this->label <<"\n";
-  //  delete widget;
+Widget::~Widget(void)
+{
+  this->destroy();
 }
 
@@ -87,18 +147,42 @@
    Initializes the next Pointer and the other Widget-specific Defaults.
 */
-void Widget::init()
+void Widget::init(void)
 {
   next = NULL;
-  label = NULL;
+  this->title = NULL;
   return;
 }
 
 /**
+   \brief Destroys a Widget 
+*/
+void Widget::destroy(void)
+{
+  if (this->title)
+    {
+      delete []this->title;
+    }
+  
+  PRINTF(4)("deleting the Widget part.\n");
+
+  PRINTF(4)("deleting recursively\n");
+
+  // deleting next item if existent
+  if (this->next)
+    delete this->next;
+  this->next = NULL;
+
+  //!  \todo not hiding widget, deleting.
+  //  this->hide();
+  //  delete this->widget;
+}
+
+/**
    \brief makes the widget visible.
 */
-void Widget::show()
-{
-#ifdef HAVE_GTK2
-  gtk_widget_show (this->widget);
+void Widget::show(void)
+{
+#ifdef HAVE_GTK2
+  gtk_widget_show(this->widget);
 #endif /* HAVE_GTK2 */
 }
@@ -107,8 +191,8 @@
    \brief hides the widget.
 */
-void Widget::hide()
-{
-#ifdef HAVE_GTK2
-  gtk_widget_hide (this->widget);
+void Widget::hide(void)
+{
+#ifdef HAVE_GTK2
+  gtk_widget_hide(this->widget);
 #endif /* HAVE_GTK2 */
 }
@@ -122,88 +206,295 @@
 {
 #ifdef HAVE_GTK2
-  gtk_widget_set_usize (this->widget, width, height);
-#endif /* HAVE_GTK2 */
-}
-
-#ifdef HAVE_GTK2
-/** 
-    \brief Connect any signal to any given Sub-widget
-*/
-gulong Widget::connectSignal (char* event, gint (*signal)(GtkWidget*, GdkEvent*, void *))
-{
-  return g_signal_connect (G_OBJECT (this->widget), event, G_CALLBACK (signal), NULL);
-}
-
-/**
-   \brief Connect a signal with additionally passing the whole Object
-*/
-gulong Widget::connectSignal (char* event, gint (*signal)( GtkWidget*, Widget *))
-{
-  return g_signal_connect (G_OBJECT (this->widget), event, G_CALLBACK (signal), this);
-}
-
-/**
-   \brief Connect a signal with additionally passing a whole external Object
-*/
-gulong Widget::connectSignal (char* event, void* extObj, gint (*signal)(GtkWidget*, GdkEvent*, void *))
-{
-  return g_signal_connect (G_OBJECT (this->widget), event, G_CALLBACK (signal), extObj);
-}
-
-/**
-   \brief Connect a signal with additionally passing a whole external Object
-*/
-gulong Widget::connectSignal (char* event, void* extObj, gint (*signal)(GtkWidget*, GdkEventKey*, void *))
-{
-  return g_signal_connect (G_OBJECT (this->widget), event, G_CALLBACK (signal), extObj);
-}
-
-void Widget::disconnectSignal (gulong signalID)
-{
-  g_signal_handler_disconnect (G_OBJECT (this->widget), signalID);
-}
-#endif /* HAVE_GTK2 */
+  gtk_widget_set_usize(this->widget, width, height);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief searches through widgets for a Name.
+*/
+Widget* Widget::findWidgetByName(char* name, unsigned int depth)
+{
+
+  if (this->title && !strcmp(this->title, name))
+    return this;
+
+  if (this->isOption < 0 && static_cast<Packer*>(this)->down)
+    {
+      Widget* tmp = static_cast<Packer*>(this)->down->findWidgetByName(name, depth+1);
+      if (tmp)
+	return tmp;
+    }
+  
+  if (depth>0 && this->next)
+    return this->next->findWidgetByName(name, depth);
+
+  return NULL;
+}
 
 /**
    \brief Moves through all the Widgets downwards from this and executes the function on them.
-   \param Function must be of type void and takes a Widget* as an Input. 
-*/
-void Widget::walkThrough (void (*function)(Widget*))
+   \param function must be of type void and takes a Widget* as an Input. 
+   \param depth the current depth. if > 0 then the next Widget will also be walked through.
+*/
+void Widget::walkThrough(void(*function)(Widget*), unsigned int depth)
 {
   function(this);
   if (this->isOption < 0)
     {
-      static_cast<Packer*>(this)->down->walkThrough (function);
+      static_cast<Packer*>(this)->down->walkThrough(function, depth+1);
     } 
 
-  if (this->next != NULL)
-    this->next->walkThrough(function);
+  if (this->next && depth != 0)
+    this->next->walkThrough(function, depth);
+}
+
+/**
+   \brief Moves through all the Widgets downwards from this and executes the function on them.
+   \param function must be of type void and takes a Widget* as an Input.
+   \param data Additional Data you want to pass to the function.
+   \param depth the current depth. if > 0 then the next Widget will also be walked through.
+*/
+void Widget::walkThrough(void(*function)(Widget*, void*), void* data, unsigned int depth)
+{
+  function(this, data);
+  if (this->isOption < 0)
+    {
+      static_cast<Packer*>(this)->down->walkThrough(function, data, depth+1);
+    }
+  if (this->next && depth != 0)
+    this->next->walkThrough(function, data, depth);
 }
 
 /** 
-    \brief This is for listing the option of "widget"
+    \brief This is for listing the options of "widget"
     \param widget specifies the widget that should be listed
 */
-void Widget::listOptions (Widget* widget)
+void Widget::listOptionsAndGroups(Widget* widget)
 {
   if (widget->isOption < 0 && static_cast<Packer*>(widget)->groupName)
     cout << "[" << static_cast<Packer*>(widget)->groupName << "]\n";
   if (widget->isOption >= 1 && widget->isOption <= 3)
-    cout << "  " << static_cast<Option*>(widget)->label <<" is : " << static_cast<Option*>(widget)->value <<endl;
+    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<Option*>(widget)->value <<endl;
   else if (widget->isOption == 5)
-    cout << "  " << static_cast<Option*>(widget)->label <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
-}
-
+    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
+}
+
+/** 
+    \brief This is for listing the options of "widget"
+    \param widget specifies the widget that should be listed
+*/
+void Widget::listOptions(Widget* widget)
+{
+  if (widget->isOption >= 1 && widget->isOption <= 3)
+    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<Option*>(widget)->value <<endl;
+  else if (widget->isOption == 5)
+    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
+}
+
+/** 
+    \brief This is for listing the options of "widget"
+    \param widget specifies the widget that should be listed
+    \param data A Counter, that always knows how many Options have been found yet.
+*/
+void Widget::listOptions(Widget* widget, void* data)
+{
+  
+  if (widget->isOption >= 1 && widget->isOption <= 3)
+    {
+      int* count =(int*)data;
+      *count = *count +1;
+      cout << *count << ": " << static_cast<Option*>(widget)->title <<" is : " << static_cast<Option*>(widget)->value <<endl;
+    }
+  else if (widget->isOption == 5)
+    {
+      int* count =(int*)data;
+      *count = *count +1;
+      cout << *count << ": " << static_cast<Option*>(widget)->title <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
+    }
+}
+
+/** 
+    \brief Finds an Option by a given number(the n'th option found away from this Widget)
+    \param number The Count of options to wait(by reference)
+    \param depth The depth of the sarch. if 0 it will not search next pointer
+    
+    \todo should return Option* would be much sexier.
+*/
+Widget* Widget::findOptionByNumber(int* number, unsigned int depth)
+{
+  if (isOption > 0)
+    {
+      --*number;
+      if (*number <= 0)
+	{
+	  return this;
+	}
+    }
+  if (this->isOption < 0 && static_cast<Packer*>(this)->down)
+    {
+      Widget* tmp = static_cast<Packer*>(this)->down->findOptionByNumber(number, depth+1);
+      if (tmp)
+	return tmp;
+    }
+  if (depth>0 && this->next)
+    return this->next->findOptionByNumber(number, depth);
+
+  return NULL;
+}
+
+/** 
+    \brief This is for listing the groups of "widget"
+    \param widget specifies the widget that should be listed
+*/
+void Widget::listGroups(Widget* widget)
+{
+  if (widget->isOption < 0 && static_cast<Packer*>(widget)->groupName)
+    cout << "[" << static_cast<Packer*>(widget)->groupName << "]\n";
+}
+
+/** 
+    \brief This is for listing the Groups of "widget". It also displays the n'th number found.
+    \param widget specifies the widget that should be listed
+    \param data the Counter, that will show the number(this function will raise it by one if a Group is fount.
+*/
+void Widget::listGroups(Widget* widget, void* data)
+{
+  if (widget->isOption < 0 && static_cast<Packer*>(widget)->groupName)
+    {
+      int* count =(int*)data;
+      *count = *count +1;
+      cout << *count <<": [" << static_cast<Packer*>(widget)->groupName << "]\n";
+    }
+}
+
+/** 
+    \brief Finds a Group by a given number(the n'th Group found away from this Widget)
+    \param number The Count of options to wait(by reference)
+    \param depth The depth of the sarch. if 0 it will not search next pointer
+*/
+Widget* Widget::findGroupByNumber(int* number, unsigned int depth)
+{
+  if (isOption < 0 && static_cast<Packer*>(this)->groupName)
+    {
+      --*number;
+      if (*number <= 0)
+	{
+	  return this;
+	}
+    }
+  if (this->isOption < 0 && static_cast<Packer*>(this)->down)
+    {
+      Widget* tmp = static_cast<Packer*>(this)->down->findGroupByNumber(number, depth+1);
+      if (tmp)
+	return tmp;
+    }
+  if (depth>0 && this->next)
+    return this->next->findGroupByNumber(number, depth);
+
+  return NULL;
+}
+ 
 /** 
     \brief This is for setting the option of "widget"
     \param widget specifies the widget that should be set.
 */
-void Widget::setOptions (Widget* widget)
+void Widget::setOptions(Widget* widget)
 {
   if (widget->isOption >= 1)
-    static_cast<Option*>(widget)->redraw();// <<" is : " << static_cast<Option*>(this)->value <<endl;
-}
-
-#ifdef HAVE_GTK2
+    static_cast<Option*>(widget)->redraw();
+}
+
+/**
+   \brief Walks through all the Flags given at startuptime.
+*/
+void Widget::flagCheck(Widget* widget, void* flagName)
+{
+  if (widget->isOption>=1)
+    {      
+      Option* option =(Option*)widget;
+      char* name =(char*)flagName;
+      char* value = NULL;
+      bool found = false;
+      // check if long flag matches
+      if ((option->flagName && strlen(name)>2 && !strncmp(name+2, option->flagName, strlen(option->flagName)) &&(name[strlen(option->flagName)+2] == '\0' || name[strlen(option->flagName)+2] == '=') ))
+	{
+	  found = true;
+	  if (name[strlen(option->flagName)+2] == '=')
+	    {
+	      value = name+strlen(option->flagName)+3;
+	    }
+	}
+      else if (option->flagNameShort && strlen(name)>1 && !strncmp(name+1, option->flagNameShort, strlen(option->flagNameShort))&&(name[strlen(option->flagNameShort)+1] == '\0' || name[strlen(option->flagNameShort)+1] == '=')) // check if short flag matches
+	{
+	  found = true;
+	  if (name[strlen(option->flagNameShort)+1] == '=')
+	    {
+	      value = name+strlen(option->flagNameShort)+2;
+	    }	  
+	}
+
+      if (found)
+	{
+	  PRINT(3)("found matching Flag %s\n", name);
+	  if (value)
+	    {
+	      PRINT(3)("with Value %s\n", value);
+	      option->value = atoi(value);
+	    }
+	  else
+	    {
+	      option->value = !option->defaultValue;
+	    }
+	  option->redraw();
+	}
+
+    }
+}
+
+#ifdef HAVE_GTK2
+/** 
+    \brief Connect any signal to any given Sub-widget
+*/
+gulong Widget::connectSignal(char* event, gint(*signal)(GtkWidget*, GdkEvent*, void *))
+{
+  return g_signal_connect(G_OBJECT(this->widget), event, G_CALLBACK(signal), NULL);
+}
+
+/**
+   \brief Connect a signal with additionally passing the whole Object
+*/
+gulong Widget::connectSignal(char* event, gint(*signal)( GtkWidget*, Widget *))
+{
+  return g_signal_connect(G_OBJECT(this->widget), event, G_CALLBACK(signal), this);
+}
+
+/**
+   \brief Connect a signal with additionally passing a whole external Object
+*/
+gulong Widget::connectSignal(char* event, void* extObj, gint(*signal)(GtkWidget*, GdkEvent*, void *))
+{
+  return g_signal_connect(G_OBJECT(this->widget), event, G_CALLBACK(signal), extObj);
+}
+
+/**
+   \brief Connect a signal with additionally passing a whole external Object
+*/
+gulong Widget::connectSignal(char* event, void* extObj, gint(*signal)(GtkWidget*, void *))
+{
+  return g_signal_connect(G_OBJECT(this->widget), event, G_CALLBACK(signal), extObj);
+}
+
+/**
+   \brief Connect a signal with additionally passing a whole external Object
+*/
+gulong Widget::connectSignal(char* event, void* extObj, gint(*signal)(GtkWidget*, GdkEventKey*, void *))
+{
+  return g_signal_connect(G_OBJECT(this->widget), event, G_CALLBACK(signal), extObj);
+}
+
+void Widget::disconnectSignal(gulong signalID)
+{
+  g_signal_handler_disconnect(G_OBJECT(this->widget), signalID);
+}
 
 /**
@@ -213,5 +504,5 @@
    \param nothing nothin.
 */
-gint Widget::doNothingSignal (GtkWidget *widget, GdkEvent* event, void* nothing)
+gint Widget::doNothingSignal(GtkWidget *widget, GdkEvent* event, void* nothing)
 {
 }
@@ -228,8 +519,8 @@
    Sets the down-pinter to NULL and other PackerSpecific-values to their defaults.
 */
-void Packer::init (void)
-{
-  down = NULL;
-  groupName = NULL;
+void Packer::init(void)
+{
+  this->down = NULL;
+  this->groupName = NULL;
 
 
@@ -239,13 +530,31 @@
 
 /**
+   \brief Destroys a Packer.
+*/
+void Packer::destroy(void)
+{ 
+  PRINTF(4)("deleting the Packer part.\n");
+  
+  if (this->groupName)
+    delete []this->groupName;
+
+  //deleting recursively.
+  if (this->down)
+    delete this->down;
+  this->down = NULL;
+
+  static_cast<Widget*>(this)->destroy();
+}
+
+/**
    \brief Sets the group name under which all the lower widgets of this will be saved.
    \param name The name of the group.
 */
-void Packer::setGroupName (char* name)
-{
-  if (groupName)
-    delete groupName;
-  groupName = new char [strlen(name)+1];
-  strcpy(groupName, name);
+void Packer::setGroupName(char* name)
+{
+  if (this->groupName)
+    delete []this->groupName;
+  this->groupName = new char[strlen(name)+1];
+  strcpy(this->groupName, name);
 }
 
@@ -254,7 +563,7 @@
    \returns name The name of the group.
 */
-char* Packer::getGroupName (void)
-{
-  return groupName;
+char* Packer::getGroupName(void)
+{
+  return this->groupName;
 }
 
@@ -266,11 +575,21 @@
    sets the Container-Specific defaults.
 */
-void Container::init (void)
-{
-  isOption = -1;
+void Container::init(void)
+{
+  this->isOption = -1;
 
   static_cast<Packer*>(this)->init();
 
   return;
+}
+
+/**
+   \brief Destroys a Container.
+*/
+void Container::destroy(void)
+{ 
+  PRINTF(4)("deleting the Container part.\n");
+
+  static_cast<Packer*>(this)->destroy();
 }
 
@@ -281,18 +600,18 @@
    It does this by filling up the down pointer only if down points to NULL.
 */
-void Container::fill (Widget *lowerWidget)
+void Container::fill(Widget *lowerWidget)
 {
   if (this->down == NULL)
     {
 #ifdef HAVE_GTK2
-      gtk_container_add (GTK_CONTAINER (this->widget), lowerWidget->widget);
+      gtk_container_add(GTK_CONTAINER(this->widget), lowerWidget->widget);
 #endif /* HAVE_GTK2 */
       this->down = lowerWidget;
     }
   else
-    cout << "!!error!! You try to put more than one Widget into a Container. \nNot including this item.\nThis is only possible with Boxes.\n"<<endl;
-}
-
-// gtk_container_set_border_width (GTK_CONTAINER (widget), 5);
+    PRINTF(1)("!!error!! You try to put more than one Widget into a Container. \nNot including this item.\nThis is only possible with Boxes.\n");
+}
+
+// gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
 
 /* WINDOW */
@@ -303,5 +622,5 @@
    \brief Adds a new Window Windows to the List of Windows.
    \param windowToAdd The Windows that should be added to the List
-   \todo this instead of windowToAdd (possibly)
+   \todo this instead of windowToAdd(possibly)
 */
 void Window::addWindow(Window* windowToAdd)
@@ -314,5 +633,5 @@
 
   Widget* tmpWindow = mainWindow;
-  while (tmpWindow->next)
+  while(tmpWindow->next)
     tmpWindow = tmpWindow->next;
   tmpWindow->next = windowToAdd;
@@ -322,9 +641,8 @@
       
 
-
 /**
    \brief Creating a new Window without a Name
 */
-Window::Window (void)
+Window::Window(void)
 {
   this->init();
@@ -335,8 +653,17 @@
    \param windowName the name the window should get.
 */
-Window::Window (char* windowName)
+
+Window::Window(char* windowName)
 {
   this->init();
-  this->setTitle (windowName);
+  this->setTitle(windowName);
+}
+
+/**
+   \brief Destructs a Window.
+*/
+Window::~Window(void)
+{
+  this->destroy();
 }
 
@@ -344,5 +671,5 @@
    \brief initializes a new Window
 */
-void Window::init()
+void Window::init(void)
 {
   if (!mainWindow)
@@ -354,11 +681,25 @@
 
 #ifdef HAVE_GTK2
-  widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
-  gtk_window_set_policy (GTK_WINDOW(widget), TRUE, TRUE, TRUE);
+  widget = gtk_window_new(GTK_WINDOW_TOPLEVEL);
+  gtk_window_set_policy(GTK_WINDOW(widget), TRUE, TRUE, TRUE);
 #if !defined(__WIN32__)
-  //  gtk_window_set_decorated (GTK_WINDOW (widget), FALSE);
+  //  gtk_window_set_decorated(GTK_WINDOW(widget), FALSE);
 #endif 
-  gtk_container_set_border_width (GTK_CONTAINER (widget), 3);
-#endif /* HAVE_GTK2 */
+  gtk_container_set_border_width(GTK_CONTAINER(widget), 3);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a Window.
+*/
+void Window::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the Window: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Window.\n");
+  //  this->hide();
+  static_cast<Container*>(this)->destroy();
+  
 }
 
@@ -366,19 +707,19 @@
    \brief Shows all Widgets that are included within this->widget.
 */
-void Window::showall ()
-{
-  if (!isOpen)
-    {
-      //      printf ("showall\n");
-#ifdef HAVE_GTK2
-      gtk_widget_show_all  (widget);
+void Window::showall(void)
+{
+  if (!this->isOpen)
+    {
+      //      printf("showall\n");
+#ifdef HAVE_GTK2
+      gtk_widget_show_all(this->widget);
 #endif /* HAVE_GTK2 */ 
-     isOpen = true;
+     this->isOpen = true;
     }
   else
     {
-      //      printf ("showone\n");
-#ifdef HAVE_GTK2
-      gtk_widget_show (widget);
+      //      printf("showone\n");
+#ifdef HAVE_GTK2
+      gtk_widget_show(this->widget);
 #endif /* HAVE_GTK2 */
     }
@@ -389,12 +730,12 @@
    \param title title the Window should get.
 */
-void Window::setTitle (char* title)
-{
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
-#ifdef HAVE_GTK2
-  gtk_window_set_title (GTK_WINDOW (widget), title);
+void Window::setTitle(char* title)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
+#ifdef HAVE_GTK2
+  gtk_window_set_title(GTK_WINDOW(widget), title);
 #endif /* HAVE_GTK2 */
 }
@@ -403,5 +744,5 @@
    \brief opens up a Window and fixes the Focus to it
 */
-void Window::open()
+void Window::open(void)
 {
   if (this != mainWindow)
@@ -409,6 +750,6 @@
       isOpen = true;
 #ifdef HAVE_GTK2
-      gtk_widget_show_all(widget);
-      gtk_grab_add(widget);
+      gtk_widget_show_all(this->widget);
+      gtk_grab_add(this->widget);
 #endif /* HAVE_GTK2 */
     }
@@ -418,19 +759,19 @@
    \brief closes up a Window and removes the Focus from it
 */
-void Window::close()
+void Window::close(void)
 {
   if (this != mainWindow)
     {
-      isOpen = false;
-#ifdef HAVE_GTK2
-      gtk_grab_remove(widget);
-      gtk_widget_hide (widget);
-#endif /* HAVE_GTK2 */
-    }
-}
-
-#ifdef HAVE_GTK2
-/**
-   \brief opens up a window (not topmost Window).
+      this->isOpen = false;
+#ifdef HAVE_GTK2
+      gtk_grab_remove(this->widget);
+      gtk_widget_hide(this->widget);
+#endif /* HAVE_GTK2 */
+    }
+}
+
+#ifdef HAVE_GTK2
+/**
+   \brief opens up a window(not topmost Window).
    this is the Signal that does it. !!SIGNALS ARE STATIC!!
    \param widget the widget that did it.
@@ -438,5 +779,5 @@
    \param window the Window that should be opened
 */
-gint Window::windowOpen (GtkWidget *widget, GdkEvent* event, void* window)
+gint Window::windowOpen(GtkWidget *widget, GdkEvent* event, void* window)
 {
   static_cast<Window*>(window)->open();
@@ -444,5 +785,5 @@
 
 /**
-   \brief closes a window (not topmost Window).
+   \brief closes a window(not topmost Window).
    this is the Signal that does it. !!SIGNALS ARE STATIC!!
    \param widget the widget that did it!
@@ -450,24 +791,9 @@
    \param window the Window that should be closed
 */
-gint Window::windowClose (GtkWidget *widget, GdkEvent* event, void* window)
+gint Window::windowClose(GtkWidget *widget, GdkEvent* event, void* window)
 {
   static_cast<Window*>(window)->close();
 }
 
-/**
- * Quits the orxonox_GUI.
- * This can be called as a Signal and is therefor static
- \param widget The widget that called this function
- \param event the event that happened to execute this function
- \param data some data passed with the Signal
- */
-gint Window::orxonox_gui_quit (GtkWidget *widget, GdkEvent *event, gpointer data)
-{
-  if (exec->shouldsave())
-    exec->writeToFile (Window::mainWindow);
-
-  gtk_main_quit();
-  return FALSE;
-}
 #endif /* HAVE_GTK2 */
 
@@ -478,5 +804,5 @@
     \brief Creates a new Frame without a name
 */
-Frame::Frame (void)
+Frame::Frame(void)
 {
   this->init();
@@ -486,5 +812,5 @@
    \brief Creates a new Frame with name title
 */
-Frame::Frame (char* title)
+Frame::Frame(char* title)
 {
   this->init();
@@ -492,15 +818,36 @@
 }
 
+/**
+   \brief destrcucts a Frame
+*/
+Frame::~Frame(void)
+{
+  this->destroy();
+}
+
 /** 
     \brief Initializes a new Frame with default settings
 */
-void Frame::init()
+void Frame::init(void)
 {
   static_cast<Container*>(this)->init();
 
 #ifdef HAVE_GTK2
-  widget = gtk_frame_new ("");
-  gtk_container_set_border_width (GTK_CONTAINER (widget), 3);
-#endif /* HAVE_GTK2 */
+  this->widget = gtk_frame_new("");
+  gtk_container_set_border_width(GTK_CONTAINER(this->widget), 3);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a Frame.
+*/
+void Frame::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the Frame: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Frame.\n");
+
+   static_cast<Container*>(this)->destroy();
 }
 
@@ -509,12 +856,12 @@
    \param title The title the Frame should get.
 */
-void Frame::setTitle (char* title)
-{
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
-#ifdef HAVE_GTK2
-  gtk_frame_set_label (GTK_FRAME (widget), title);
+void Frame::setTitle(char* title)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
+#ifdef HAVE_GTK2
+  gtk_frame_set_label(GTK_FRAME(widget), title);
 #endif /* HAVE_GTK2 */
 }
@@ -525,13 +872,14 @@
    \brief Creates a new EventBox with default settings.
 */
-EventBox::EventBox ()
+EventBox::EventBox(void)
 {
   this->init();
 }
+
 /**
    \brief Creates a new EventBox with name title
-   \param title title the Eventbox should get (only data-structure-internal)
-*/
-EventBox::EventBox (char* title)
+   \param title title the Eventbox should get(only data-structure-internal)
+*/
+EventBox::EventBox(char* title)
 {
   this->init();
@@ -540,28 +888,50 @@
 
 /**
+   \brief destructs an EventBox.
+*/
+EventBox::~EventBox(void)
+{
+  this->destroy();
+
+}
+
+/**
    \brief Initializes a new EventBox
 */
 void EventBox::init(void)
 {
-  isOption = -1;
+  this->isOption = -1;
 
   static_cast<Container*>(this)->init();
 
 #ifdef HAVE_GTK2
-  widget = gtk_event_box_new ();
-  gtk_container_set_border_width (GTK_CONTAINER (widget), 3);
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Sets the Title of the EventBox (not implemented)
-   \param title Name the EventBox should get (only datastructure-internal).
-*/
-void EventBox::setTitle (char* title)
-{
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  this->widget = gtk_event_box_new();
+  gtk_container_set_border_width(GTK_CONTAINER(this->widget), 3);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys an EventBox.
+*/
+void EventBox::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the EventBox: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the EventBox.\n");
+
+  static_cast<Container*>(this)->destroy();
+}
+
+/**
+   \brief Sets the Title of the EventBox(not implemented)
+   \param title Name the EventBox should get(only datastructure-internal).
+*/
+void EventBox::setTitle(char* title)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -571,5 +941,5 @@
    \brief Creates a new horizontal Box
 */
-Box::Box (void)
+Box::Box(void)
 {
   this->init('h');
@@ -580,7 +950,15 @@
    \param boxtype if 'v' the Box will be vertically, if 'h' the Box will be horizontally
 */
-Box::Box (char boxtype)
+Box::Box(char boxtype)
 {
   this->init(boxtype);
+}
+
+/**
+   \brief destructs a Box.
+*/
+Box::~Box(void)
+{
+  this->destroy();
 }
 
@@ -591,5 +969,5 @@
 void Box::init(char boxtype)
 {
-  isOption = -2;
+  this->isOption = -2;
 
   static_cast<Packer*>(this)->init();
@@ -597,12 +975,24 @@
   if (boxtype == 'v')
     {
-      widget = gtk_vbox_new (FALSE, 0);
+      this->widget = gtk_vbox_new(FALSE, 0);
     }
   else
     {
-      widget = gtk_hbox_new (FALSE, 0);
-    }
-#endif /* HAVE_GTK2 */
-
+      this->widget = gtk_hbox_new(FALSE, 0);
+    }
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a Box.
+*/
+void Box::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the Box: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Box.\n");
+
+  static_cast<Packer*>(this)->destroy();
 }
 
@@ -613,8 +1003,8 @@
     It does this by apending the first one to its down-pointer and all its following ones to the preceding next-pointer. The last one will receive a NULL pointer as Next
 */
-void Box::fill (Widget *lowerWidget)
-{
-#ifdef HAVE_GTK2
-  gtk_box_pack_start (GTK_BOX (this->widget), lowerWidget->widget, TRUE, TRUE, 0);
+void Box::fill(Widget* lowerWidget)
+{
+#ifdef HAVE_GTK2
+  gtk_box_pack_start(GTK_BOX(this->widget), lowerWidget->widget, TRUE, TRUE, 0);
 #endif /* HAVE_GTK2 */
   if (this->down == NULL)
@@ -624,5 +1014,5 @@
       Widget* tmp;
       tmp = this->down;
-      while (tmp->next != NULL)
+      while(tmp->next != NULL)
 	{
 	  tmp = tmp->next;
@@ -632,33 +1022,15 @@
 }
 
-/* IMAGE */
-
-/**
-   \brief Creates a new Image
-   \param imagename the location of the Image on the Hard Disc
-*/
-Image::Image (char* imagename)
-{
-  this->init();
-  if (label)
-    delete []label;
-  label = new char[strlen(imagename)+1];
-  strcpy(label, imagename);
-
-#ifdef HAVE_GTK2
-  widget = gtk_image_new_from_file (imagename);
-#endif /* HAVE_GTK2 */
-}
-
-/** 
-    \brief Initializes a new Image
-*/
-void Image::init()
-{
-  isOption = 0;
-
-  static_cast<Widget*>(this)->init();
-}
-
+/**
+   \brief Sets the Title of a Box.
+   \param title the new Title to set.
+*/
+void Box::setTitle(char* title)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
+}
 
 /* OPTION */
@@ -668,15 +1040,29 @@
    sets all Option-Specific-Values to their defaults.
 */
-void Option::init()
-{
-  value = 0;
-  flagName = NULL;
-  flagNameShort = NULL;
-  saveable = false;
-  defaultValue = 0;
+void Option::init(void)
+{
+  this->value = 0;
+  this->flagName = NULL;
+  this->flagNameShort = NULL;
+  this->saveable = false;
+  this->defaultValue = 0;
 
   static_cast<Widget*>(this)->init();
 
   return;
+}
+
+/**
+   \brief Destroys an Option.
+*/
+void Option::destroy(void)
+{ 
+  PRINTF(4)("deleting the Option Part.\n");
+  if (this->flagName)
+    delete []this->flagName;
+  if (this->flagNameShort)
+    delete []this->flagNameShort;
+
+  static_cast<Widget*>(this)->destroy();
 }
 
